from Components.Language import language
from Tools.Directories import resolveFilename, SCOPE_LANGUAGE
import os, gettext, sys

PluginLanguageDomain = "myfreemp3"
PluginLanguagePath = "/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Po"

def localeInit():
    lang = language.getLanguage()[:2] 
    os.environ["LANGUAGE"] = lang 
    gettext.bindtextdomain(PluginLanguageDomain, PluginLanguagePath)
    gettext.bindtextdomain('enigma2', resolveFilename(SCOPE_LANGUAGE, ""))

def _(txt):
    t = gettext.dgettext(PluginLanguageDomain, txt)
    if t == txt:		
      t = gettext.dgettext('enigma2', txt)
    return t

localeInit()
language.addCallback(localeInit)
