# -*- coding: UTF-8 -*-
from imports import *
from enigma import eTimer, eConsoleAppContainer, eBackgroundFileEraser, iServiceInformation
from Components.ProgressBar import ProgressBar
container= eConsoleAppContainer()
from Setup import *
from enigma import iPlayableService, eTimer, eServiceCenter, iServiceInformation, ePicLoad, getDesktop
from Tools.Downloader import HTTPProgressDownloader, downloadWithProgress
from Language import _

if (getDesktop(0).size().width() < 1920):
  Directory = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/Sd'
else:
  Directory = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/Hd'

  
def OnclearMem():
    system("sync")
    system("echo 3 > /proc/sys/vm/drop_caches")
                
ENIGMA_SERVICE_ID = 4097
DEFAULT_VIDEO_PID = 0x44
DEFAULT_AUDIO_PID = 0x45

class InfoBarMedia(Screen,InfoBarSeek):        
    def __init__(self, session,Title):     
        self.session = session	
        skin = Directory+"/Info.xml"
        if os.path.exists(skin):  
          f = open(skin, "r")
          self.skin = f.read()
          f.close()					  
        Screen.__init__(self, session)
        self["service"] = Label(Title)		
        self.isTSVideo = True	
        self.seekBarLocked = False	
        InfoBarSeek.__init__(self)		
        self.Loop = eTimer()		
        try:			
          self.Loop.callback.append(self.close)  
        except:		
          self.activityTimer_conn1 = self.Loop.timeout.connect(self.close) 	  	       	   	
        self.Loop.start(10000,True)			
        self["myActionMap"] = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"],
        {		
        "ok": self.close,	
        "info": self.close,					
        "red": self.close	
        }, -1)	

                                        
class PlayerIptv(Screen,InfoBarBase, InfoBarSeek):        
    def __init__(self, session,url,Title,IptvTimer='3',Adulti = False):     
        self.session = session	
        skin = Directory+"/Play.xml"
        if os.path.exists(skin):  
          f = open(skin, "r")
          self.skin = f.read()
          f.close()						
        Screen.__init__(self, session)	
        InfoBarBase.__init__(self)
        InfoBarSeek.__init__(self)	
        self["progress"] = ProgressBar()
        self["progress"].setValue(0)	
        OnclearMem()		
        self.progress = 0	
        self["Key_Red"] = Label(_("Exit"))	
        self["Key_Green"] = Label("")
        self['green'] = Pixmap()	
        self['green'].hide()		
        self['red'] = Pixmap()	
        self['red'].show()	
        self['infobar'] = Pixmap()	
        self['infobar'].show()		
        self.url = url
        self.Title = Title
        self["service"] = Label(self.Title)		
        self.IptvTimer = IptvTimer
        self["Tot"] = Label('| '+self.IptvTimer+' Mb')
        self["Parz"] = Label("0 Mb | ")	
        self["Avviso"] = Label("")		
        self.lastservice = session.nav.getCurrentlyPlayingServiceReference()
        self.lastservice1 = ''
        self.LoopService = eTimer()
        self.Loop = eTimer()
        self.LoopBuffering = eTimer()
        self.LoopBufferingPlay = eTimer()
        self.LoopPlay = eTimer()
        self.LoopProgressBuffering = eTimer()
        self.LoopProgressBufferingMem = eTimer()
        self.LoopBufferingMem = eTimer()
        try:			
          self.LoopService.callback.append(self.StopService)  	
          self.Loop.callback.append(self.CicleTimer)  		
          self.LoopBuffering.callback.append(self.BufferingControl)  			
          self.LoopBufferingPlay.callback.append(self.Player)  		
          self.LoopPlay.callback.append(self.play)  		
          self.LoopProgressBuffering.callback.append(self.ProgressBuffering)  		
          self.LoopProgressBufferingMem.callback.append(self.ProgressBufferingMem) 		
          self.LoopBufferingMem.callback.append(self.BufferingMem)  		  
        except:			
          self.activityTimer_conn1 =self.LoopService.timeout.connect(self.StopService)  	
          self.activityTimer_conn2 =self.Loop.timeout.connect(self.CicleTimer)  		
          self.activityTimer_conn3 =self.LoopBuffering.timeout.connect(self.BufferingControl)  			
          self.activityTimer_conn4 =self.LoopBufferingPlay.timeout.connect(self.Player)  		
          self.activityTimer_conn5 =self.LoopPlay.timeout.connect(self.play)  		
          self.activityTimer_conn6 =self.LoopProgressBuffering.timeout.connect(self.ProgressBuffering)  		
          self.activityTimer_conn7 =self.LoopProgressBufferingMem.timeout.connect(self.ProgressBufferingMem) 		
          self.activityTimer_conn8 =self.LoopBufferingMem.timeout.connect(self.BufferingMem)       	

        self.Prime = False		
        self.Count = 0		
        self.CicleInfo = False		
        self.Http = False	
        self.ForcePlay = False		
        self.PlayLock = True
        self.seekstate = None
        self.OkInfo = False			
        self.Adulti = Adulti		
        self.Storage,self.Download,self.Buffering =load()	
        if self.url.find('http') != -1 or self.url.find(DlPath()) != -1 or self.url.find('Ms_Download') != -1 or self.url.find('Ms_Mp3') and not self.url.find('Streaming.mp4') != -1:	    
          if self.Storage == '/':
            self["Tot"] = Label('')
            self["Parz"] = Label("")	
            self["Avviso"] = Label("")	
            self.OffPlayForce = False	
            self.Prime = True
            self.play()				
            self.Count = 99999		
          elif Adulti :
            self["Tot"] = Label('')
            self["Parz"] = Label("")	
            self["Avviso"] = Label("")	
            self.OffPlayForce = False	
            self.LoopPlay.start(10,True)
            self.Count = 99999					
          else:			
            self.OffPlayForce = True	
            self.Http = True	
            self.OnBuffering = True		
            self.startDownload()	
        else:		 
          if self.Storage != '/':		
            self.OnBuffering = True		
            self.Loop.start(2*1000,True)					
            self.OffPlayForce = True		
        self["myActionMap"] = ActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions", "EPGSelectActions"],
        {	
        "ok": self.info,	
        "info": self.info,			
        "green": self.PlayForce,	
        "cancel": self.precancel,		
        "red": self.precancel	
        }, -1)		
                
    def BufferingMem(self): 
        self.progress = 0
        self.ProgressBufferingMem()
        self["Avviso"].setText(_("Buffering cache\nAttendere!"))
        self['infobar'].show()
        self.seekstate = self.SEEK_STATE_PAUSE
        self.setSeekState(self.SEEK_STATE_PAUSE)	
        self.LoopBufferingPlay.start(100*1000,True)  

    def ProgressBufferingMem(self):
        self.progress = self.progress+1
        self["progress"].setValue(self.progress)
        if self.progress < 100:
          self.LoopProgressBufferingMem.start(1000,True)
        elif self.progress == 100:
          self["progress"].setValue(0)
                
    def BufferingControl(self):
        if self.Adulti:
          TimerLimit = 0
        else:
          TimerLimit = 85	
        if not self.Adulti:  	  
          if self.Prime:
            self.Prime = False	
            self.LoopBufferingMem.start(10,True)
            return		  
        self.TimeBuff = str(InfoBarSeek.calcRemainingTime(self))
        if self.seekstate == self.SEEK_STATE_PLAY:
          try:	
            if self.PlayLock or container.running():		 
              if int(self.TimeBuff) < TimerLimit:
                self.Pause()
                try:
                  self.LoopBuffering.stop()
                except:
                  pass	
              else:		
                self.LoopBuffering.start(100,True) 
            else:			
              return				  
          except:				
            self.LoopBuffering.start(3000,True) 			 
                
    def PlayForce(self):
        self.ForcePlay = True
        self['infobar'].hide()	
        self.LoopPlay.start(1000,True)
        
    def ResetTxt(self):
        try:		
          self['green'].hide()
          self['red'].hide()	
          self['infobar'].hide()		
          self["Key_Green"].setText('')
          self["Key_Red"].setText('')  
          self["service"].setText('') 	  
          self["progress"].setValue(0)
          self["Tot"].setText('')
          self["Parz"].setText('')
          self["Avviso"].setText("")			
        except:
          pass  	
                                                
    def ProgressBuffering(self):
        self.progress = self.progress+1
        self["progress"].setValue(self.progress)
        if self.progress < 100:
          self.LoopProgressBuffering.start(100,True)
        elif self.progress == 100:
          self["progress"].setValue(0)
                
    def Player(self):
        self["Avviso"].setText("")
        self["progress"].setValue(0)
        self.PlayLock = True
        self.seekstate = self.SEEK_STATE_PLAY	
        InfoBarSeek.doSeekRelative(self,-1)
        self.setSeekState(self.SEEK_STATE_PLAY)	
        self.ResetTxt()
        self.LoopBuffering.start(5000,True) 
        
    def Pause(self):
        if not self.PlayLock and not container.running():
          return	  
        self.progress = 0
        self.ProgressBuffering()
        self["Avviso"].setText(_("Wait .. ... Buffering insufficient."))	
        self['infobar'].show()
        self.seekstate = self.SEEK_STATE_PAUSE
        self.setSeekState(self.SEEK_STATE_PAUSE)	
        self.LoopBufferingPlay.start(10*1000,True)
 
    def info(self):
        self.session.open(InfoBarMedia,self.Title)
 
    def infox(self):
        if self.OkInfo:
          self.OkInfo = False
          self.StopService()
        else:	
          self.OkInfo = True
          self.CicleInfo = True
          try:	
            self['green'].hide()
            self['red'].show()	
            self['infobar'].show()	
            self["Key_Green"].setText('')
            self["Key_Red"].setText("Exit")  
            self["service"].setText(self.Title) 	 
            self.LoopService.start(15000,True)	  
          except:
            pass  
                
    def StopService(self):
        try:	
          self.LoopService.stop()	
        except:
          pass  			
        self.CicleInfo = False	
        try:		 
          self.ResetTxt()		
        except:
          pass  	
      
    def precancel(self):
        if self.CicleInfo:
          self.StopService()
        else:	   
          self.session.openWithCallback(self.cancel,MessageBox,_("would you like to go out?"),MessageBox.TYPE_YESNO, timeout = 20)
        
    def doEofInternal(self, playing):	
        service = self.session.nav.getCurrentService()
        if service:
          self.seek = service.seek()
          if self.seek:
            length = self.seek.getLength()
            position = self.seek.getPlayPosition()	
            try:
              if position[1] == length[1] or ( length[1] - position[1] ) < 9000 :
                self.cancel(True)		  
                return
            except:
              pass	
        if self.PlayLock or container.running() and not self.Adulti:		 
            self.Pause()	
            return					  
        self.cancel(True)
        
    def lockShow(self):	
        if self.seekstate != self.SEEK_STATE_PAUSE:
          self.doEofInternal(True)
                
    def unlockShow(self):
        pass

    def startDownload(self):
        self.currentDownload = downloadWithProgress(str(self.url), self.Storage+'/Streaming.mp4')	
        self.currentDownload.addProgress(self.CicleTimer)
        self.currentDownload.start().addCallback(self.stopDownload).addErrback(self.downloadFailed)
                
    def downloadFailed(self):
        self.PlayLock = False	
        try:
          self.currentDownload.stop()
        except:
          pass		
        self["Avviso"].setText(_("Sorry !! Error buffering\nPress red to exit"))
        self['infobar'].show()
        self["Tot"].setText('')
        
    def stopDownload(self):	
        self.PlayLock = False	
        try:
          self.currentDownload.stop()	
        except:
          pass        		
        self["Tot"].setText('')
        
    def CicleTimer(self, receivedBytes=None, totalBytes=False):
        if receivedBytes > 100 and receivedBytes == totalBytes:
          self.PlayLock = False		
        if self.ForcePlay:
          return
        if self.Http:            
          self.url = self.Storage+'/Streaming.mp4'	
        if totalBytes:
          if int(self.IptvTimer) >= float(int(totalBytes)/1024/1024):
            self.IptvTimer = float(int(totalBytes)/1024/1024)
            if int(float(os.path.getsize(self.url)) / float(int(self.IptvTimer) *1024*1024) * 100) < 99:
              self["Tot"].setText('| '+str(self.IptvTimer)+' Mb')
        if not self.OnBuffering:
          return
        try:
          jSize = os.path.getsize(self.url)/1024/1024	
        except:
          jSize = 0	 
        try:
          jSizeStart = os.path.getsize(self.url)
        except:
          jSizeStart = 0			   
        try:
          self.progress = int(float(os.path.getsize(self.url)) / float(int(self.IptvTimer) *1024*1024) * 100)		
        except:
          self.progress = 0		
        self['infobar'].show()		
        self["Parz"].setText(str(jSize)+' Mb | ')
        self["progress"].setValue(self.progress)
        if jSizeStart == 0:
          self["Avviso"].setText(_("Connection.....\nWait .....")+str(self.Count))	
          if self.Count == 4:		
            self["Avviso"].setText(_("Connection.....\nWait last check"))	
          if self.Count == 5:
            self["progress"].setValue(0)
            self.cancel(True)
            return
          if not self.Http:		
            self.Loop.start(10*1000)
          self.Count = self.Count+1		
        else:
          self.Count = 0
          self["Avviso"].setText("")	  
          self.OffPlayForce	= False
          self['green'].show()	
          self['red'].show()	
          self['infobar'].show()		
          self["Key_Green"].setText(_('Force Play'))			
          if jSize < int(self.IptvTimer) :
            if not self.Http:
              self.Loop.start(500)
          else:
            if self.OnBuffering:						
              try:
                self.Loop.stop()
              except:
                pass	
              self.LoopPlay.start(1000,True)			
            if self.Http:			
              self.OnBuffering = False									
                
    def cancel(self, answer):
        if answer :	
          try:
            self.LoopBuffering.stop()
          except:
            pass			
          self.session.nav.stopService()
          self.session.nav.playService(self.lastservice)	
          container.kill()	
          os.system('killall -9 rtmpdump')		
          os.system('rm -fr '+self.Storage+'/Streaming*')
          self.stopDownload()	
          OnclearMem()			
          self.close()     
                
    def play(self):		
        if self.OffPlayForce:
          return			
        try:	
          self.ResetTxt()	
          self.session.nav.stopService()   	
          self.fileRef = eServiceReference(ENIGMA_SERVICE_ID, 0, str(self.url))
          self.fileRef.setData(0,DEFAULT_VIDEO_PID)
          self.fileRef.setData(1,DEFAULT_AUDIO_PID)
          self.session.nav.playService(self.fileRef)	
          self.seekstate = self.SEEK_STATE_PLAY	
          self.PlayLock = True		
          self.LoopBuffering.start(3000,True) 
        except:
          pass  
        try:			  
          self.Loop.stop()
        except:
          pass  		
        self.OffPlayForce = True		
                
