# -*- coding: UTF-8 -*-
from imports import *
from Language import _

if (getDesktop(0).size().width() < 1920):
  Directory = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/Sd'
else:
  Directory = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/Hd'
  
def ListPartizion():
    Partizion = False
    st = statvfs("/media/hdd")
    free = st.f_bavail * st.f_frsize  
    if free > 1073741824: # Valore in Bytes Superiore a 1gb
      Partizion = True	
    return Partizion	

def Hdd(partition = None):	  
    Size = Used = Avaible = UsedP = Mount = ""
    try:	
      if partition == None:	  
        partition = config.myfreemp3.storage.value   
      st = statvfs (partition)
      totSize = st.f_blocks * st.f_frsize;
      freeSize = st.f_bfree * st.f_frsize;
      usedSize = totSize - freeSize;
      availableSize = totSize - usedSize;
      percent = (100*usedSize) / totSize;   
      suffixMb = " Mb";
      suffixGb = " Gb";
      oneGb = 1024*1000*1000
      oneMb = 1024*1000   
      if totSize > oneGb:
        Size = str(totSize / oneGb) + suffixGb;
      else:
        Size = str(totSize / oneMb) + suffixMb;       
      if usedSize > oneGb:
        Used = str(usedSize / oneGb) + suffixGb;
      else:
        Used = str(usedSize / oneMb) + suffixMb;    
      if availableSize > oneGb:          
        Avaible = str(availableSize / oneGb) + suffixGb;
      else:
        Avaible = str(availableSize / oneMb) + suffixMb;    
      UsedP = str(percent) + "%";
      Mount = partition;
    except:
      pass
    return Size,Used ,Avaible ,UsedP,Mount 
                
def isMountedInRW(path):
    if (os.access (path,os.W_OK)):
      return True
    return False

def Mounted():
    jpartitions = []
    for partition in harddiskmanager.getMountedPartitions():
      if (isMountedInRW(partition.mountpoint)):
        moviePath = os.path.join (partition.mountpoint,"movie");
        try:
          os.mkdir (moviePath)
        except:
          pass
        jpartitions.append((partition.mountpoint,partition.description))
    return jpartitions

def SaveConf():
    a = open("/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/SaveConf", "w")
    a.write("--- Team myfreemp3  ---\n\n")   
    a.write("Storage Buffering= %s\n" % (config.myfreemp3.storage.value))	
    a.write("Storage Download = %s\n" % (config.myfreemp3.storage1.value))		
    a.write("BufferingIptv = %s\n" % (config.myfreemp3.MbBuffering.value))								
    a.write("\n\n--- By m43c0 & mmark --- ")                                     
    a.close()	

def SaveConfPornStatus():
    a = open("/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/SaveStatusPorn", "w")
    a.write("--- Team myfreemp3  ---\n\n")   
    a.write("On-Off-Adulti = %s\n" % (config.myfreemp3.adulti.value))	
    a.write("Active-Pin = %s\n" % (config.myfreemp3.pornpin.value))		
    a.write("Porn-Pin = %s\n" % (config.myfreemp3.pincode.value))					
    a.write("\n\n--- By m43c0 & mmark --- ")                                     
    a.close()
        
def loadPornStatus():
    ActivePorn = AcrivePin = ''	
    PornPin = 0
    if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/SaveStatusPorn"):                   		   
      try:
        xf = open("/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/SaveStatusPorn", "r")
        f = xf.readlines()				
        xf.close()		
      except:
        pass					   
      for line in f:
        try:
          LoadConf = line.strip()
          elements = LoadConf.split('=')				 
          if LoadConf.find('On-Off-Adulti') != -1 :
            ActivePorn =  elements[1][1:]
            config.myfreemp3.adulti.setValue(ActivePorn)	
          elif LoadConf.find('Active-Pin') != -1 :
            AcrivePin =  elements[1][1:]
            config.myfreemp3.pornpin.setValue(AcrivePin)  	
          elif LoadConf.find('Porn-Pin') != -1 :
            PornPin =  int(elements[1][1:])
            config.myfreemp3.pincode.setValue(PornPin)            	
        except:
          pass
    return ActivePorn ,AcrivePin ,PornPin
        
def load():
    Storage='/'
    Download='/'	
    Buffering=3	
    if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/SaveConf"):                   		   
      try:
        xf = open("/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Moduli/SaveConf", "r")
        f = xf.readlines()				
        xf.close()		
      except:
        pass					   
      for line in f:
        try:
          LoadConf = line.strip()
          elements = LoadConf.split('=')				 	
          if LoadConf.find('Storage Buffering') != -1 :
            for x,y in Mounted():
              if str(x) == str(elements[1][1:]):
                try:		
                  config.myfreemp3.storage.setValue(str(elements[1][1:]))
                  Storage=str(elements[1][1:])
                  break
                except:
                  pass
              else:		
                config.myfreemp3.storage.setValue(Storage)		
          elif LoadConf.find('Storage Download') != -1 :
            for x,y in Mounted():
              if str(x) == str(elements[1][1:]):
                try:		
                  config.myfreemp3.storage1.setValue(str(elements[1][1:]))
                  Download=str(elements[1][1:])
                  break
                except:
                  pass
              else:		
                config.myfreemp3.storage1.setValue(Download)							
          elif LoadConf.find('BufferingIptv') != -1 :				
            try:		
              config.myfreemp3.MbBuffering.setValue(int(elements[1][1:]))	
            except:
              pass							
            Buffering=str(elements[1][1:])			
        except:
          pass  			
    return Storage,Download,Buffering
        
def DlPath():
    Storage,Download,Buffering =load()
    if Download == '/':
      Download = '/media/usb/'	  
    return Download+'/movie'	
        

def MyConfig():	
    config.myfreemp3 = ConfigSubsection()	
    config.myfreemp3.adulti = ConfigSelection(default = "Yes", choices = [("Yes", _("Yes")),("No", _("No"))])	
    config.myfreemp3.pornpin = ConfigSelection(default = "Yes", choices = [("Yes", _("Yes")),("No", _("No"))])
    config.myfreemp3.pincode = ConfigPIN(default = 0000)	
    config.myfreemp3.storage = ConfigSelection(default = "/", choices = Mounted())	
    config.myfreemp3.MbBuffering = ConfigInteger(default = 50, limits = (1,99))
    config.myfreemp3.storage1 = ConfigSelection(default = "/", choices = Mounted())					
    load() 
    SaveConf()	
    loadPornStatus()		
    SaveConfPornStatus()
        
MyConfig()
        
class MyConfigMain(Screen, ConfigListScreen):

    def __init__(self, session):
        self.session = session
        path = Directory+"/Setup.xml"
        with open(path, "r") as f:
          self.skin = f.read()
          f.close()                       
        Screen.__init__(self, session)
        self['title'] = Label("Menu Setup" )      
        self['hdd'] = Label("" )
        self.red = Label("")
        self["Info"] = self.red               
        self.configlist = []					
        self["config"] = ConfigList(self.configlist)	  			
        ConfigListScreen.__init__(self, self.configlist, session = self.session)               
        self["actions"]  = NumberActionMap(["OkCancelActions", "ShortcutActions", "WizardActions", "ColorActions", "SetupActions", "NumberActions", "MenuActions","EPGSelectActions"], {
             "ok"    : self.keyOK,
             "cancel": self.keyCancel,
             "up"  : self.keyUp,				
             "down"  : self.keyDown,
             "cancel": self.keyCancel,			
             "left"  : self.keyLeft,				
             "right" : self.keyRight						
        }, -1)
        MyConfig()	    			
        self.onShown.append(self.MyConfigList)			
        self.LoopPannelC = eTimer()
        try:			
          self.LoopPannelC.callback.append(self.StorageInfo) 
        except:		
          self.activityTimer_conn1 = self.LoopPannelC.timeout.connect(self.StorageInfo)	       	   	
        self.LoopPannelC.start(5000,True)   
                               
    def keyUp(self):
        self["config"].instance.moveSelection(self["config"].instance.moveUp)
        self.MyConfigList()			

    def keyDown(self):
        self["config"].instance.moveSelection(self["config"].instance.moveDown)
        self.MyConfigList()						
                    
    def keyRight(self):	
        self["config"].handleKey(KEY_RIGHT)
        self.MyConfigList()
                            
    def keyLeft(self):	
        self["config"].handleKey(KEY_LEFT)	
        self.MyConfigList()
                            
    def StorageInfo(self):		
        list = ""
        for x,j in Mounted():				
          Size,Used,Available,UsedPerc,Mount  = Hdd(x)		
          list = str(list)+j.title()+' : '+str(Available)+'\n'			  		  	
        self['hdd'].setText(str(list )) 
                    
    def MyConfigList(self):			
        self.configlist = []	               
        self.configlist.append(getConfigListEntry(_("View Adult Section"), config.myfreemp3.adulti,'OnOffAdulti'))	
        if config.myfreemp3.adulti.value == 'Yes' :		
          self.configlist.append(getConfigListEntry(_("Protect Adult Section with password"), config.myfreemp3.pornpin,'OnOffPassword'))
          if config.myfreemp3.pornpin.value == 'Yes' :   
            self.configlist.append(getConfigListEntry(_("Password Adult Section"), config.myfreemp3.pincode,'Password'))					
        self.configlist.append(getConfigListEntry(_("Storage device for Buffering"), config.myfreemp3.storage,'storage'))
        if config.myfreemp3.storage.value != '/' :
          if os.path.exists('/usr/bin/rtmpdump'):	
            self.configlist.append(getConfigListEntry(_("MB Buffering Video"), config.myfreemp3.MbBuffering,'BufferingIptv'))						
        self.configlist.append(getConfigListEntry(_("Storage Device for Download"), config.myfreemp3.storage1,'storage1'))				
        self["config"].list = self.configlist		
        self["config"].l.setList(self.configlist)  				
                                                            
    def keyOK(self):
        for x in self["config"].list:
          x[1].save()			
        SaveConf()
        SaveConfPornStatus()	
        try:			
          self.LoopPannelC.stop()	
        except:
          pass			  
        self.close()		          
          
    def keyCancel(self):	
        try:			
          self.LoopPannelC.stop()	
        except:
          pass			
        self.close()	
