# -*- coding: UTF-8 -*-
from Components.Harddisk import harddiskmanager
from Components.Button import Button
from Components.Label import Label
from Components.ScrollLabel import ScrollLabel
from Components.ConfigList import ConfigListScreen,ConfigList
from Components.Sources.StaticText import StaticText
from Components.ActionMap import NumberActionMap, ActionMap
from Components.config import config, ConfigInteger, ConfigSelection, getConfigListEntry, ConfigText, ConfigDirectory, ConfigYesNo, configfile, ConfigSelection, ConfigSubsection, ConfigPIN, NoSave, ConfigNothing, KEY_LEFT, KEY_RIGHT
from Components.FileList import FileList, FileEntryComponent
from Components.GUIComponent import GUIComponent
from Components.MenuList import MenuList
from Components.Pixmap import Pixmap, MovingPixmap
from Components.PluginList import PluginEntryComponent, PluginList
from Components.AVSwitch import AVSwitch
from Components.MultiContent import MultiContentEntryText, MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest,MultiContentEntryProgress
from Components.ServiceEventTracker import ServiceEventTracker, InfoBarBase
from enigma import  quitMainloop,loadPic, eServiceCenter,gFont, addFont, eTimer, eConsoleAppContainer, ePicLoad, loadPNG, getDesktop, eServiceReference, iPlayableService, eListboxPythonMultiContent, RT_HALIGN_LEFT, RT_HALIGN_RIGHT, RT_HALIGN_CENTER, RT_VALIGN_CENTER, eListbox, gPixmapPtr
from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Screens.ChoiceBox import ChoiceBox
from Screens.MessageBox import MessageBox
from Screens.InputBox import PinInput,InputBox
from Screens.InfoBarGenerics import InfoBarSeek, InfoBarNotifications
from Screens.InfoBar import MoviePlayer as MP_parent
from Tools import Notifications
from Screens.InfoBar import InfoBar
from Screens.Standby import TryQuitMainloop
from twisted.web.client import downloadPage, getPage, error
from twisted.internet import reactor
from twisted.internet import defer
from Tools.Directories import fileExists, resolveFilename, SCOPE_PLUGINS, SCOPE_LANGUAGE
from Tools.LoadPixmap import LoadPixmap
from urllib2 import Request,HTTPError, URLError, urlopen as urlopen2
from socket import gaierror, error
from urllib import quote, unquote_plus, unquote, urlencode
from httplib import HTTPConnection, CannotSendRequest, BadStatusLine, HTTPException
from time import strptime, mktime
from base64 import b64decode
from binascii import unhexlify
from time import *
from Screens.VirtualKeyBoard import VirtualKeyBoard
from ServiceReference import ServiceReference
from Components.Input import Input
from cookielib import CookieJar
import re, urllib, urllib2, cookielib, time,sha, shutil,os,sys, xml.etree.cElementTree,glob, base64,datetime,math,hashlib,json, random, gettext
from os import system,statvfs,popen,path
from JobsMs import * 
from cStringIO import StringIO
from xml.dom import minidom

StatusSkin = 'HD'
if (getDesktop(0).size().width() < 1920):
  Directory = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/Sd'
  StatusSkin = 'SD'
else:
  Directory = '/usr/lib/enigma2/python/Plugins/Extensions/myfreemp3/Skin/Hd'
  StatusSkin = 'HD'
  
def Modello():
    try:
      from enigma import eMediaDatabase
      is7080hd = True
    except:
      from Components.Network import iNetwork
      try:
        file = open("/proc/stb/info/model", "r")
        dev = file.readline().strip()
        file.close()
        if dev == "dm7080":
          is7080hd = True
        else:
          is7080hd = False
      except:
        is7080hd = False
	
def NetworkStatus():
  if not Modello():
    try:
      iNetwork.loadNameserverConfig()
      return iNetwork.getNameserverList()[0]
    except:
      return

def HTML(text):
    text = text.replace('&Auml;','Ae').replace('\u00c4','Ae').replace('&#196;','Ae').replace('&ouml;','oe').replace('\u00f6','oe')
    text = text.replace('&#246;','oe').replace('&ouml;','Oe').replace('\u00d6','Oe').replace('&#214;','Oe').replace('&uuml;','ue')
    text = text.replace('\u00fc','ue').replace('&#252;','ue').replace('&Uuml;','Ue').replace('\u00dc','Ue').replace('&#220;','Ue')	
    text = text.replace('&szlig;','ss').replace('\u00df','ss').replace('&#223;','ss').replace('&amp;','&').replace('&quot;','\"')
    text = text.replace('&gt;','\'').replace('&apos;',"'").replace('&acute;','\'').replace('&ndash;','-').replace('&bdquo;','"')
    text = text.replace('&rdquo;','"').replace('&ldquo;','"').replace('&lsquo;','\'').replace('&rsquo;','\'').replace('&#038;','&')
    text = text.replace('&#039;','\'').replace('&#160;',' ').replace('&#174;','').replace('&#225;','a').replace('&#233;','e').replace('&#39;','\'')
    text = text.replace('&#243;','o').replace('&#8211;',"-").replace('&#8216;',"'").replace('&#8217;',"'").replace('&#8220;',"'")
    text = text.replace('&#8221;','"').replace('&#8222;',',').replace('&#8230;','...')
    text = text.replace('&auml;','ae').replace('&Auml;','Ae').replace('&ouml;','oe').replace('&ouml;','Oe').replace('&uuml;','ue')
    text = text.replace('&Uuml;','Ue').replace('&szlig;','ss').replace('&amp;','&').replace('&quot;','\"').replace('&gt;','\'')
    text = text.replace('&#228;','ae').replace('&#246;','oe').replace('&#252;','ue').replace('&#223;','ss').replace('&#8230;','...')
    text = text.replace('&#8222;',',').replace('&#8220;',"'").replace('&#8216;',"'").replace('&#8217;',"'").replace('&#8211;',"-")
    text = text.replace('&#8230;','...').replace('&#8217;',"'").replace('&#128513;',":-)").replace('&#8221;','"')
    text = text.replace('\u00c4','Ae').replace('\u00e4;',"ae").replace('\u00d6',"Oe").replace('\u00f6','oe')
    text = text.replace('\u00dc','Ue').replace('\u00fc',"ue").replace('\u00df',"ss").replace('&amp',"&")
    text = text.replace('&ndash','–').replace('&mdash',"—").replace('&iexcl',"¡").replace('&iquest',"¿")  
    text = text.replace('&quot','"').replace('&ldquo',"“").replace('&rdquo',"”").replace('&lsquo',"‘")  
    text = text.replace('&rsquo','’').replace('&laquo',"«").replace('&raquo',"»").replace('&nbsp'," ")    
    text = text.replace('<strong>','').replace('</strong>',"").replace('&auml;','ae').replace('\u00e4','ae').replace('&#228;','ae')
    text = text.replace('&auml;','ä').replace('\u00e4','ä').replace('&#228;','ä').replace('&Auml;','Ä').replace('\u00c4','Ä').replace('&#196;','Ä')
    text = text.replace('&ouml;','ö').replace('\u00f6','ö').replace('&#246;','ö').replace('&ouml;','Ö').replace('&Ouml;','Ö').replace('\u00d6','Ö')
    text = text.replace('&#214;','Ö').replace('&uuml;','ü').replace('\u00fc','ü').replace('&#252;','ü').replace('&Uuml;','Ü').replace('\u00dc','Ü')
    text = text.replace('&#220;','Ü').replace('&szlig;','ß').replace('\u00df','ß').replace('&#223;','ß').replace('&amp;','&').replace('&quot;','\"')
    text = text.replace('&gt;','>').replace('&apos;',"'").replace('&acute;','\'').replace('&ndash;','-').replace('&bdquo;','"').replace('&rdquo;','"')
    text = text.replace('&ldquo;','"').replace('&lsquo;','\'').replace('&rsquo;','\'').replace('&#034;','\'').replace('&#038;','&').replace('&#0039;','\'')
    text = text.replace('&#160;',' ').replace('\u00a0',' ').replace('\u00b4','\'').replace('&#174;','').replace('&#225;','a').replace('&#233;','e')
    text = text.replace('&#243;','o').replace('&#8211;',"-").replace('\u2013',"-").replace('&#8216;',"'").replace('&#8217;',"'")
    text = text.replace('&#8220;',"'").replace('&#8221;','"').replace('&#8222;',',').replace('\u201e','\"').replace('\u201c','\"').replace('\u201d','\'')
    text = text.replace('\u2019s','\'').replace('\u00e0','à').replace('\u00e7','ç').replace('\u00e9','é').replace('&#xC4;','Ä').replace('&#xD6;','Ö')
    text = text.replace('&#xDC;','Ü').replace('&#xE4;','ä').replace('&#xF6;','ö').replace('&#xFC;','ü').replace('&#xDF;','ß').replace('&#xE9;','é')
    text = text.replace('&#xB7;','·').replace("&#x27;","'").replace("&#x26;","&").replace("&#xFB;","û").replace("&#xF8;","ø")
    text = text.replace("&#x21;","!").replace("&#x3f;","?").replace('&#8230;','...').replace('\u2026','...').replace('&hellip;','...')	
    text = text.replace("&#249;","ù").replace("&#233;","è").replace('\\','').replace('&#097;','à').replace('&#97;','à').replace('&#210;','ò')			
    text = text.replace("&#224;","à").replace("&#242;","ò").replace("&#233;","é").replace("&#236;","ì").replace("&#232;","é").replace("</a>","").replace("<a>","")				
    return text	

def OnclearMem():
    system("sync")
    system("echo 3 > /proc/sys/vm/drop_caches")

import base64

def link(url,data=False):
    if not data:
      req = urllib2.Request(url)
    else:
      req = urllib2.Request(url,data)	
    try:	  
      req.add_header('User-Agent', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36')	  	  
      response = urllib2.urlopen(req,None,10)		  
      link =response.read()
      response.close()
      return link		
    except:
      pass
	  
def substr(data,start,end):
    i1 = data.find(start)
    i2 = data.find(end,i1)
    return data[i1:i2]
	
def IptvFilter(text):
    text = text.replace('playpath=','-y ').replace('swfUrl=','-s ').replace('live=',' -v ').replace('pageUrl=','-p ').replace('conn=','-C ')
    text = text.replace('app=','-a ').replace('tcUrl=','-t ').replace('flashVer=','-f ').replace('auth=','-u ').replace('playlist=','-Y ')
    text = text.replace('subscribe=','-d ').replace('resume=','-e ').replace('skip=','-k ').replace('start=','-A ').replace('stop=','-B ')
    text = text.replace('buffer=','-b ').replace('timeout=','-m ').replace('token=','-T ').replace('jtv=','-j ').replace('swfhash=','-w ')
    text = text.replace('swfsize=','-x ').replace('swfVfy=','-W ').replace('swfAge=','-X ').replace('host=','-n ').replace('port=','-c ')
    text = text.replace('protocol=','-l ').replace('socks=','-S ')
    return text

def uniq(inlist): 
    uniques = []
    for item in inlist:
      if item not in uniques:
        uniques.append(item)
    return uniques	

def loadPage(url):
    try:
      req = urllib2.Request(url)
      req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; rv:29.0) Gecko/20100101 Firefox/29.0')
      response = urllib2.urlopen(req)
      link = response.read()
      response.close()
      return link
    except:
      return





