import urllib
import urllib2
import json
import re
import math
from BeautifulSoup import BeautifulSoup

class Mediaset:

    def get_prog_root(self):
	
	url = "http://www.video.mediaset.it/programma/game15.json"
	data = json.load(urllib2.urlopen(url))
	return data["programmi"]["group"]

    def get_prog_epList(self, url):

	arrdata = []
        url = "http://www.video.mediaset.it%s" % (url)
        response = urllib2.urlopen(url)
	html = response.read()
	response.close()

	matches = re.search(r'<div class=.+video-[fF]ull.+js_boxvideo.+data-area="(.+)".+data-box="(.+)".+data-items="(.+)".+data-strip.+data-strip1="(.+)_(.+)".+data-template.+data-type="(.+)">',html)
	try:
		programma = matches.group(1)
		stagione = matches.group(2)
		maxres = int(matches.group(3))
		row = matches.group(4)
		column = matches.group(5)
		tipo = matches.group(6)
		
	except:
		return arrdata

	totres = 0
	count = 0
	page = 1
	totpage = 0
	url = "http://www.video.mediaset.it/%s/%s/%s.shtml" % (tipo,programma,stagione)

	while (count < maxres):
		nurl = "%s?page=%s&dim=%s" % (url,page,column)
        	response = urllib2.urlopen(nurl)
		html = response.read()
		response.close()
		if (totres == 0):
			try:
				matches = re.search(r'<div class="box.+data-maxitem="([0-9]+)">',html)
				totres = int(matches.group(1))
				maxres = totres
				totpage = math.ceil(float(totres) / float(column))
			except:
				break

		matches = re.findall(r'<div class="box.+data-id="([^"]+)"[\s\S]*?<figure class="imgBox">[\s\S]*?<a data-type.+title="([^"]+)".+href="([^"]+)".+data-src="([^"]+)"[\s\S]*?<p class="descr">([\s\S]*?)<',html)
		for res in matches:
			
			tmp = str(BeautifulSoup(res[1],convertEntities=BeautifulSoup.HTML_ENTITIES))
			a = {'id': res[0],'titolo':tmp,'thumbs':res[3].replace("176x99","640x360"),'desc':res[4]}
			arrdata.append(a);
			count = count +1

		page = page +1
		if page > totpage: break;

        return arrdata

    def get_global_epList(self,mode,range):

	arrdata = []
	if mode == 0: 
		url = "http://www.video.mediaset.it/bacino/bacinostrip_1.shtml?page=all"
	elif mode == 1:
		url = "http://www.video.mediaset.it/piu_visti/piuvisti-%s.shtml?page=all" % range

        response = urllib2.urlopen(url)
	html = response.read()
	response.close()
  
	matches = re.findall('</div><div class="(.+?)".*?<figure class="imgBox">.*?data-src="(.+?)".+?lass="title">(.+?)</h2>.*?class="descr">(.+?)</p>',html, re.S|re.I)
	for tipo,jpg,ititle,des in matches:		
		id = re.findall('.+_(.+?)_.+.[png|jpg]',jpg, re.S|re.I)[0]
		arrdata.append((tipo,id,jpg,ititle,des))
	return arrdata
	
    def get_sport_epList(self):	
	arrdata = []
	url = "http://www.video.mediaset.it/bacino/bacinostrip_5.shtml?page=all"
	response = urllib2.urlopen(url)
	html = response.read()
	response.close()
	matches = re.findall('<figure class="imgBox">.*?href="(.+?)".*?data-src="(.+?)".+?lass="title">(.+?)</h2>.*?class="descr">(.+?)</p>',html, re.S|re.I)
	for tipo,jpg,ititle,des in matches:
		id = re.findall('.+_(.+?)_.+.[png|jpg]',jpg, re.S|re.I)[0]
		arrdata.append((tipo,id,ititle,jpg.replace("176x99","640x360"),des))

	return arrdata

    def get_stream(self, id):

	url = "http://cdnselector.xuniplay.fdnames.com/GetCDN.aspx?streamid=%s&format=json" % (id)

	response = urllib2.urlopen(url)
	html = response.read()
	response.close()

	html = html.replace('(','')
	html = html.replace(')','')
	data = json.loads(html)
	list=[]
	stream = {"wmv":"","mp4":""}
	for vlist in data["videoList"]:
		if ( vlist.find("/wmv2/") > 0): 
		  list.append(vlist)
		if ( vlist.find("/mp4/") > 0): 
		  list.append(vlist)
	return list